include:
  - template: Code-Quality.gitlab-ci.yml

stages:
  - test
  - report

variables:
  TEST_RESULTS_PATH: 'gitlab-nunit/Program.Tests/TestResults/test-run.xml'
  OBSIDIAN_PROJECT_ID: 'ec6c33e8-8244-400f-8be7-29e3097256c9'
  OBSIDIAN_ENVIRONMENT_ID: '93be8bdc-9d20-4337-857e-3e2a6b8dcb29'

test:
  stage: test
  image: mcr.microsoft.com/dotnet/core/sdk:3.1
  script:
    - cd gitlab-nunit
    - dotnet restore && dotnet test --logger "nunit;LogFileName=test-run.xml"
  artifacts:
    when: always
    paths:
      - $TEST_RESULTS_PATH
    expire_in: 1 day
    
upload-test-runs:
  stage: report
  image: node:14-alpine
  when: always
  variables:
    OBSIDIAN_MAPPER: 'obsidian-nunit-mapper'
  script:
    - yarn global add obsidian-cli $OBSIDIAN_MAPPER
    - obsidian testruns import $TEST_RESULTS_PATH
        --mapper $OBSIDIAN_MAPPER
        --environment $OBSIDIAN_ENVIRONMENT_ID
        --project $OBSIDIAN_PROJECT_ID
        --apikey $OBSIDIAN_API_KEY
        --apisecret $OBSIDIAN_API_SECRET_KEY
        --tags "tutorial, $CI_PIPELINE_SOURCE"
